indexing

	description: "Base class for child definition with children."

	author:     "Berend de Boer <berend@pobox.com>"
	copyright:  "Copyright (c) 2001 by Berend de Boer, see forum.txt"
	date:       "$Date: $"
	revision:   "$Revision: $"


deferred class

	CHILD_DEFINITION_CHILDREN


inherit

	CHILD_DEFINITION


feature -- Initialization

	make (a_children: DS_LINKED_LIST [CHILD_DEFINITION]) is
		do
			children := a_children
		end


feature -- Output

	do_do_generate (xml: EPX_XML_WRITER) is
		require
			-- attribute set, something like xml.set_attribute("type", "seq")
		local
			cursor: DS_LINEAR_CURSOR [CHILD_DEFINITION]
		do
			cursor := children.new_cursor
			from
				cursor.start
			until
				cursor.after
			loop
				cursor.item.generate (xml)
				cursor.forth
			end
		end


feature -- State

	children: DS_LINKED_LIST [CHILD_DEFINITION]


invariant

	has_children: children /= Void

end
