indexing
   
   description: "Reads an XML document and attempts to retrieve all %
                %DTD specifications from it."


class 

   TEMPLATE_PARSER


inherit
   
   XML_EVENT_PARSER
      redefine
         on_start_tag,
         on_content
      end


creation
   
   make
   

feature
   
   make (a_specification: SCHEMA_SPECIFICATION) is
      do
         schema := a_specification
      end


feature -- parsing

   create_event_parser_imp: EXPAT_EVENT_PARSER is
      do
         create Result
      end

   generate (a_file_name: UC_STRING) is
      do
         create out_file.create_write ("test.pas")
         my_parser := create_event_parser_imp
         make_from_imp (my_parser)
         parse_from_file_name (a_file_name)
         out_file.close
      end


feature -- handlers

   on_start_tag (name, 
                 ns_prefix: UC_STRING; 
                 attributes: DS_BILINEAR [DS_PAIR [DS_PAIR [UC_STRING, UCSTRING], UCSTRING]]) is
      do
         -- if foreachElement, what to do?\
         -- simply generate the AddElementChildren calls
         -- how to build the child definitions?
         if name.is_equal (rootElement) then
            out_file.puts (schema.root_element.to_utf8)
         end
      end

   on_content (chr_data: UC_STRING) is
      do
         out_file.puts (chr_data.to_utf8)
      end


feature -- ucstrings
   
   rootElement: UC_STRING is
      once
         create Result.make_from_string ("rootElement")
      end


feature -- state

   my_parser: EXPAT_EVENT_PARSER
   
   schema: SCHEMA_SPECIFICATION

   out_file: STDC_TEXT_FILE

end
