indexing

	description: "Stores all state during parsing."


class

	PARSE_STATE


creation

	make


feature {NONE} -- Initialization

	make is
		do
			create parents.make
		end


feature -- root

	doctype_root: DEFINED_ELEMENT
			-- Root as defined by <!DOCTYPE> instruction.

	set_doctype_root (a_root: DEFINED_ELEMENT) is
		require
			valid_root: a_root /= Void
		do
			doctype_root := a_root
		end

	root: DEFINED_ELEMENT
			-- Actual root, i.e. top most tag as accepted by parser.

	set_root (a_root: DEFINED_ELEMENT) is
		require
			root_unknown: root = Void -- we cannot change root on the fly
			valid_root: a_root /= Void
		do
			root := a_root
		end


feature -- Level of tags

	parents: DS_LINKED_STACK [ELEMENT_STATE]

	current_element_state: ELEMENT_STATE is
		require
			not_empty: not parents.is_empty
		do
			Result := parents.item
		ensure
			current_element_not_void: Result /= Void
		end

	current_element: DEFINED_ELEMENT is
		require
			not_empty: not parents.is_empty
		do
			Result := current_element_state.element
		ensure
			current_element_not_void: Result /= Void
		end


invariant

	parents_not_void: parents /= Void

end
