indexing

	description: "Various Helper routines."

	usage: "Inherit from this class."

	library: "Gobo Eiffel XML Library"
	copyright: "Copyright (c) 2003, Berend de Boer and others"
	license: "Eiffel Forum License v1 (see forum.txt)"
	date: "$Date: $"
	revision: "$Revision: $"


class

	XM_HELPER_ROUTINES


inherit

	KL_IMPORTED_STRING_ROUTINES


feature -- Various helper routines

	as_utf8_string (s: STRING): UC_UTF8_STRING is
			-- Needed for correct hash codes.
		require
			s_not_void: s /= Void
		local
			uc_name: UC_UTF8_STRING
		do
			uc_name ?= s
			if uc_name = Void then
				create uc_name.make_from_string (s)
			end
			Result := uc_name
		ensure
			not_void: Result /= Void
			same_string: STRING_.same_string (s, Result)
		end

	resolved_name (a_namespace, a_local_part: STRING): UC_UTF8_STRING is
			-- Concate name `a_namespace' and `a_local_part'.
		require
			local_part_not_empty: a_local_part /= Void and then not a_local_part.is_empty
		do
			if a_namespace = Void or else a_namespace.is_empty then
				Result ?= a_local_part
			else
				create Result.make (a_namespace.count + 1 + a_local_part.count)
				Result.append_string (a_namespace)
				Result.append_character (':')
				Result.append_string (a_local_part)
			end
		ensure
			result_not_empty: Result /= Void and then not Result.is_empty
			no_colon_if_no_name_space:
				a_namespace = Void or else a_namespace.is_empty implies
					not Result.has (':')
		end

end
